#  Features

## Changelog

### v 0.1.x | current is 0.1.5 (extensions for Swift language)
- Extensions for primitive values (`Bool`, `Int`, `Float`, `Double`, `String` etc.);
- Extensions for collections (`Sequence`, `Collection`, `RangeReplaceableCollection` and `Dictionary`);
- Extensions for primitive value and collection `Optional`;
- Extensions and tests for `Comparable`;
- Extensions for `TimeInterval`;
- Extensions for `Codable`, `KeyedDecodingContainer`, `PropertyListDecoder` and `TopLevelDecoder`;
- Added unit test target;
- Added CI/CD to test project and deploy pod to trunk;

## Future features

### v 0.1 | extensions for `Swift language`
- [X] Extensions for primitive values;
- [X] Extensions for collections;
- [X] Extensions for `Optional`;
- [X] Extensions for `Result`;
- [X] Extensions for `Codable` and `KeyedDecodingContainer`;
- [ ] Common blocks typealias to convinient usage;
- [ ] Multicast delegate (model which can collect multiple delegate);
- [ ] Once (method wich is called once);
- [ ] Write documentation for all extensions of this version;
- [ ] Write unit tests to check all extensions of this version

### v 0.2 | extensions for `Foundation`
- [X] Extensions for `TimeInterval`;
- [ ] Extensions for `Bundle`;
- [ ] Extensions for `Date` and `Calendar`;
- [ ] Extensions for `Locale`;
- [ ] Extensions for formatters;
- [ ] Extensions for `FileManagers`;
- [ ] Extensions for `Measurement`;
- [ ] Extensions for `NotificationCenter`;
- [ ] Extensions for `NSAttributedString`;
- [ ] Extensions for `NSObject`;
- [ ] Extensions for `NSPredicate`;
- [ ] Extensions for `NSRegularExpression`;
- [ ] Extensions for `URL` and `URLRequest`;
- [ ] Extensions for `UserDefaults`;
- [ ] Extensions for `DispatchQueue` and `DispatchGroup`;
- [ ] Extensions for `Operations` and `OperationsQueue`;
- [ ] AsyncOperationQueue (model bases on `OperationsQueue` and `DispatchSemaphore` to make it async and sireal)
- [ ] Write documentation for all extensions of this version;
- [ ] Write unit tests to check all extensions of this version

### v 0.3 | extensions for `CoreGraphics`
- [X] Extensions for `CGFloat`;
- [ ] Extensions for `CGAffineTransform`;
- [ ] Extensions for `CGColor`;
- [ ] Extensions for `CGPoint`;
- [ ] Extensions for `CGRect`;
- [ ] Extensions for `CGSize`;
- [ ] Extensions for `CGVector`;
- [ ] Write documentation for all extensions of this version;
- [ ] Write unit tests to check all extensions of this version

### v 0.4 | extensions for `CoreAnimation`
- [ ] Extensions for `CACornerMask`;
- [ ] Extensions for `CAGradientLayer`;
- [ ] Extensions for `CATransform3D`;
- [ ] Write documentation for all extensions of this version;
- [ ] Write unit tests to check all extensions of this version

### v 0.5 | extensions for `CoreData`
- [ ] Extensions for `NSManagedObject`;
- [ ] Write documentation for all extensions of this version;
- [ ] Write unit tests to check all extensions of this version

### v 0.6 | extensions for `CoreLocation`
- [ ] Extensions for `CLLocationCoordinate2D` and `CLLocation`;
- [ ] Extensions for `CLVisit`;
- [ ] Write documentation for all extensions of this version;
- [ ] Write unit tests to check all extensions of this version

### v 0.7 | extensions for `UIKit` (Part 1)
- [ ] Extensions for `UIImage`;
- [ ] Extensions for `UIColor`;
- [ ] Extensions for `UIEdgeInsets`;
- [ ] Extensions for `UIBezierPath`;
- [ ] Extensions for `UIFont`;
- [ ] Extensions for `UIGestureRecognizer`;
- [ ] Extensions for `UILayoutPriority`;
- [ ] Write documentation for all extensions of this version;
- [ ] Write unit tests to check all extensions of this version

### v 0.8 | extensions for `UIKit` (Part 2)
- [ ] Extensions for different `UIView` elements (will write about it later);
- [ ] Extensions for different `UIScrollView` elements (will write about it later);
- [ ] Actions blocks instead target for different UI elements, like button actions with blocks;
- [ ] Then, like https://github.com/devxoul/Then;
- [ ] Write documentation for all extensions of this version;
- [ ] Write unit tests to check all extensions of this version

### v 0.9 | extensions for `UIKit` (Part 3)
- [ ] Extensions for different `UIViewController` subclasses (will write about it later);
- [ ] Write documentation for all extensions of this version;
- [ ] Write unit tests to check all extensions of this version

### v 1.0 | extensions for `UIKit` (Part 4)
- [ ] Extensions for `UIWindow`;
- [ ] Extensions for `UIApplication`;
- [ ] Extensions for keyboard observing with many helpers;
- [ ] Extensions for change screen on multitasking;
- [ ] Write documentation for all extensions of this version;
- [ ] Write unit tests to check all extensions of this version

### v 1.1 | extensions for `MapKit`
- [ ] Extensions for `MKMapView`;
- [ ] Extensions for `MKPolyline`;
- [ ] Write documentation for all extensions of this version;
- [ ] Write unit tests to check all extensions of this version

### v 1.2 | extension for Other native frameworks
- [ ] Extensions for `WKWebView`;
- [ ] Extensions for `LocalAuthentication (LAContext etc.)
- [ ] Write documentation for all extensions of this version;
- [ ] Write unit tests to check all extensions of this version

### v 1.3 | extensions for `Combine`
- [X] Extensions for `TopLevelDecoder`;


##### * this is not final feature log
